#Filename:CH02_3.py
#多元計分的題目分析具有分量表
import os
os.chdir('D:\\DATA\\CH02\\')
import pandas as pd
sdata0 = pd.read_csv('CH02_2.csv')
pnum = sdata0.shape[1]-1
snum = sdata0.shape[0]
sdata2 = sdata0
sdata3 = []
i=0
while (i <= pnum-1):
    sdata1_temp=[]
    sdata1_temp.append(sdata2.iloc[:,i+1].mean())
    sdata1_temp.append(sdata2.iloc[:,i+1].std())
    sdata1_temp.append(sdata2.iloc[:,i+1].skew())
    sdata1_temp.append(sdata2.iloc[:,i+1].kurt())
    sdata3.append(sdata1_temp)
    i=i+1
sdata3 = pd.DataFrame(sdata3)
sdata3.columns =['Mean','SD','Skew','Kurt']
sdata4 = sdata2.drop(columns=['ID'])
c_sdata2 = list(sdata2)
c_sdata2.pop(0)
sdata2['psum']=sdata2[c_sdata2].sum(axis='columns')
sdata2['pmean']=sdata2['psum']/pnum
sdata2['pmean'].describe()
lb=sdata2['psum'].quantile(0.27)
hb=sdata2['psum'].quantile(0.73)
sdata2.loc[sdata2.psum>0, 'grp']='M'
sdata2.loc[sdata2.psum>=hb, 'grp']='H'
sdata2.loc[sdata2.psum<=lb, 'grp']='L'

import scipy.stats as stats
group1 = sdata2[c_sdata2[0]][sdata2['grp']=='H']
group2 = sdata2[c_sdata2[0]][sdata2['grp']=='L']
cr = stats.ttest_ind(group1,group2)
ph = (sdata2[c_sdata2[0]][sdata2['grp']=='H']).mean()
pl = (sdata2[c_sdata2[0]][sdata2['grp']=='L']).mean()
group3m = (ph+pl)/2
group4m = (ph-pl)

import pingouin as pg
from scipy.stats import pearsonr
pcr=sdata2[c_sdata2[0]].corr(sdata2['psum'], method='pearson')

sdata3 = []
i=0
while (i <= pnum-1):
    sdata1_temp=[]
    sub_df = sdata4.drop(c_sdata2[i], axis=1)
    ac = pg.cronbach_alpha(sub_df)
    scale_mean = sub_df.mean().sum()
    variance = sub_df.sum(axis=1).var()
    pr = pearsonr(sub_df.mean(axis=1), sdata4[c_sdata2[i]])
    sdata1_temp.append(scale_mean)
    sdata1_temp.append(variance)
    sdata1_temp.append(pr[0])
    sdata1_temp.append(ac[0])
    sdata3.append(sdata1_temp) 
    i=i+1
sdata3 = pd.DataFrame(sdata3)
sdata3.columns =['SMean','SVar','Ir','IA']

sdata3 = []
i=0
while (i <= pnum-1):
    sdata1_temp=[]
    sdata1_temp.append(sdata2.iloc[:,i+1].mean())
    sdata1_temp.append(sdata2.iloc[:,i+1].std())
    sdata1_temp.append(sdata2.iloc[:,i+1].skew())
    sdata1_temp.append(sdata2.iloc[:,i+1].kurt())
    ph = (sdata2[c_sdata2[i]][sdata2['grp']=='H']).mean()
    pl = (sdata2[c_sdata2[i]][sdata2['grp']=='L']).mean()
    sdata1_temp.append(ph)
    sdata1_temp.append(pl)
    sdata1_temp.append((ph+pl)/2)
    sdata1_temp.append(ph-pl)    
    cr = stats.ttest_ind(sdata2[c_sdata2[i]][sdata2['grp']=='H'],sdata2[c_sdata2[i]][sdata2['grp']=='L'])
    sdata1_temp.append(cr.statistic)
    sdata1_temp.append(cr.pvalue)
    sdata1_temp.append(sdata2[c_sdata2[i]].corr(sdata2['psum'], method='pearson'))

    sub_df = sdata4.drop(c_sdata2[i], axis=1)
    ac = pg.cronbach_alpha(sub_df)
    scale_mean = sub_df.mean().sum()
    variance = sub_df.sum(axis=1).var()
    pr = pearsonr(sub_df.mean(axis=1), sdata4[c_sdata2[i]])
    sdata1_temp.append(scale_mean)
    sdata1_temp.append(variance)
    sdata1_temp.append(pr[0])
    sdata1_temp.append(ac[0])

    sdata3.append(sdata1_temp) 
    i=i+1
sdata3 = pd.DataFrame(sdata3)
sdata3.columns =['Mean','SD','Skew','Kurt','PH','PL','P','D','CR','p','r','SMean','SVar','Ir','IA']

Cresult = ''
Cresult = Cresult + 'No Mean SD Skew  Kurt  PH  PL  P  D  CR  p  r  SMean  SVar  Ir  IA \n'
for i in range(0, sdata3.shape[0]):
    Cresult = Cresult +'第'+str(i)+'題 '
    for j in range(0,sdata3.shape[1]):
        Cresult = Cresult+" "+str(sdata3.iloc[i][j].round(4))+" "
    Cresult = Cresult +'\n'

fp = open('result2.txt','w', encoding="utf-8")
print(Cresult, file=fp)
fp.close()

sub = [
['B101','B102','B103','B104','B105','B106'],
['B201','B202','B203','B204','B205','B206'],
['B301','B302','B303','B304','B305','B306'],
['B401','B402','B403','B404','B405','B406']]

sdata5 = []
j=0
while (j < len(sub)):
    sub_index = 'B'+str(j)
    sdata2[sub_index]=sdata2[sub[j]].sum(axis='columns')
    i=0
    while (i<len(sub[j])):
        sdata1_temp=[]
        s1=list(sub[j])
        sdata1_temp.append(sdata2[s1[i]].corr(sdata2[sub_index], method='pearson'))
        s1.pop(i)
        sub_df = sdata2[s1]
        ac = pg.cronbach_alpha(sub_df)
        sdata1_temp.append(ac[0])
        sdata5.append(sdata1_temp)
        i=i+1
    j=j+1
sdata5 = pd.DataFrame(sdata5)
sdata5.columns =['r2','IA2']
Cresult = ''
Cresult = Cresult + 'No Mean SD Skew  Kurt  PH  PL  P  D  CR  p  r  SMean  SVar  Ir  IA r2 IA2\n'
for i in range(0, sdata3.shape[0]):
    Cresult = Cresult +'第'+str(i)+'題 '
    for j in range(0,sdata3.shape[1]):
        Cresult = Cresult+" "+str(sdata3.iloc[i][j].round(4))+" "
    for j in range(0,sdata5.shape[1]):
        Cresult = Cresult+" "+str(sdata5.iloc[i][j].round(4))+" "    
    Cresult = Cresult +'\n'
fp = open('result3.txt','w', encoding="utf-8")
print(Cresult, file=fp)
fp.close()