#Filename:CH03_1.py
#量表信度與效度分析(信度)
#更改工作目錄
import os
os.chdir('D:\\DATA\\CH03\\')
import pandas as pd
sdata0 = pd.read_csv('CH03_1.csv')
pnum = sdata0.shape[1]-1
snum = sdata0.shape[0]
#ID不用分析
c_sdata0.pop(0)
#利用pingouin 計算 cronbach's alpha
import pingouin as pg
cronbach1 = sdata0[c_sdata0]
#輸出格式是tuple
t_alpha = pg.cronbach_alpha(cronbach1)
print("問卷的Alpha信度為",t_alpha)
#計算折半信度
import numpy as np
from scipy.stats import pearsonr
#刪除不要分析的ID
sdata1 = sdata0.drop(columns=['ID'])
print(sdata1.head())
split_num = int((int(len(sdata1.columns)) if ((int(len(sdata1.columns)) % 2) == 0) else int(len(sdata1.columns)+1) ) / 2 )
dfs = np.split(sdata1, [split_num], axis=1)
#亦即將串列dfs[0]與dfs[1]二個串列進行相關係數的計算
print(dfs[0])
pearson = pearsonr(dfs[0].mean(axis=1),dfs[1].mean(axis=1))[0]
spearman_brown = (2*pearson)/(1+pearson)
a_croncha_1 = round(pg.cronbach_alpha(data=dfs[0])[0],3)
a_croncha_2 = round(pg.cronbach_alpha(data=dfs[1])[0],3)
print("問卷的pearson為",pearson)
print("問卷的spearman_brown為",spearman_brown)
print("alpha1為",a_croncha_1)
print("alpha2為",a_croncha_2)
#計算分量表的信度
sub = [
['B101','B102','B103','B104','B105','B106'],
['B201','B202','B203','B204','B205','B206'],
['B301','B302','B303','B304','B305','B306'],
['B401','B402','B403','B404','B405','B406']]
j=0
while (j < len(sub)):
    sub_df = sdata0[sub[j]]
    ac = pg.cronbach_alpha(sub_df)
    print('第'+str(j)+'分量表:'+str(ac[0].round(4)))
    j=j+1