#Filename:CH04_1.py
#獨立樣本t考驗
#更改工作目錄
import os
os.chdir('D:\\DATA\\CH04\\')
import pandas as pd
sdata0 = pd.read_csv('CH04_1.csv')
#檢視分析的欄位
print(sdata0[['GENDER','JOB','A0101']].describe())
sdata1 = sdata0.copy()
sdata1['A01']=sdata1[['A0101','A0102','A0103','A0104','A0105','A0106']].mean(axis='columns')
sdata1['A02']=sdata1[['A0201','A0202','A0203','A0204','A0205','A0206']].mean(axis='columns')
sdata1['A03']=sdata1[['A0301','A0302','A0303','A0304']].mean(axis='columns')
sdata1['A04']=sdata1[['A0401','A0402','A0403']].mean(axis='columns')
sdata1['A00']=sdata1[['A01','A02','A03','A04']].mean(axis='columns')
print(sdata1[['GENDER','A01','A02','A03','A04','A00']].head())

from scipy import stats
print('平均數',sdata1['A01'].mean().round(4), '標準差',sdata1['A01'].std().round(4))
#進行單一樣本t檢定  檢定平均數是否大於2.5(1,4)
stats.ttest_1samp(sdata1['A01'], 2.5)
#進行獨立樣本t檢定
import researchpy as rp
import scipy.stats as stats
#同質性檢定
stats.levene(sdata1['A01'][sdata1['GENDER']==1],sdata1['A01'][sdata1['GENDER']==2],center='mean')
group1=sdata1['A01'][sdata1['GENDER']==1]
group2=sdata1['A01'][sdata1['GENDER']==2]
print(group1.describe())
print(group2.describe())
#變異數同質
stats.ttest_ind(group1,group2,equal_var=False)
#變異數不同質
stats.ttest_ind(group1,group2,equal_var=True)
#另外一種方式researchpy  rp.ttest()
import researchpy as rp
rp.ttest(group1=sdata1['A01'][sdata1['GENDER']==1], group1_name='Male',
         group2=sdata1['A01'][sdata1['GENDER']==2], group2_name='Female')
rp.ttest(group1=sdata1['A02'][sdata1['GENDER']==1], group1_name='Male',
         group2=sdata1['A02'][sdata1['GENDER']==2], group2_name='Female')
rp.ttest(group1=sdata1['A03'][sdata1['GENDER']==1], group1_name='Male',
         group2=sdata1['A03'][sdata1['GENDER']==2], group2_name='Female')
rp.ttest(group1=sdata1['A04'][sdata1['GENDER']==1], group1_name='Male',
         group2=sdata1['A04'][sdata1['GENDER']==2], group2_name='Female')
rp.ttest(group1=sdata1['A00'][sdata1['GENDER']==1], group1_name='Male',
         group2=sdata1['A00'][sdata1['GENDER']==2], group2_name='Female')