#Filename:CH03_3.py
#量表信度與效度分析(驗證性因素分析)
#更改工作目錄
import os
os.chdir('D:\\DATA\\CH03\\')
import pandas as pd
sdata0 = pd.read_csv('CH03_1.csv')
pnum = sdata0.shape[1]-1
snum = sdata0.shape[0]
sdata1 = sdata0.drop(columns=['ID'])
print(sdata1.columns)
#開始進行驗證性因素分析
from semopy import Model
mod=""" 
    f1 =~ B101+B102+B103+B104+B105+B106
    f2 =~ B401+B402+B403+B404+B405+B406
    f3 =~ B303+B304+B305+B306
    f4 =~ B201+B202+B203
    """
model = Model(mod)
res = model.fit(sdata1)
print(res)
ins = model.inspect(std_est = True)
print(ins)
import semopy
pstats = semopy.calc_stats(model)
print(pstats)
print(pstats.T)
#第1次修正模型
mod=""" 
    f1 =~ B101+B102+B103
    f2 =~ B401+B405+B406
    f3 =~ B304+B305+B306
    f4 =~ B201+B202+B203
    """
model = Model(mod)
res = model.fit(sdata1)
print(res)
ins = model.inspect(std_est = True)
print(ins)
import semopy
pstats = semopy.calc_stats(model)
print(pstats)
#繪製圖形
import graphviz
g = semopy.semplot(model, 'sem3.jpg')
g = semopy.semplot(model, 'sem4.jpg', plot_covs=True)