#Filename:CH06_1.py
#相關分析
#更改工作目錄
import os
os.chdir('D:\\DATA\\CH06\\')
import pandas as pd
sdata0 = pd.read_csv('CH06_1.csv')
sdata1 = sdata0.copy()
#A總和
sdata1['A01']=sdata1[['A0101','A0102','A0103','A0104','A0105','A0106']].mean(axis='columns')
sdata1['A02']=sdata1[['A0201','A0202','A0203','A0204','A0205','A0206']].mean(axis='columns')
sdata1['A03']=sdata1[['A0301','A0302','A0303','A0304']].mean(axis='columns')
sdata1['A04']=sdata1[['A0401','A0402','A0403']].mean(axis='columns')
sdata1['A00']=sdata1[['A01','A02','A03','A04']].mean(axis='columns')
#A單題平均
sdata1['SA01']=sdata1[['A0101','A0102','A0103','A0104','A0105','A0106']].sum(axis='columns')
sdata1['SA02']=sdata1[['A0201','A0202','A0203','A0204','A0205','A0206']].sum(axis='columns')
sdata1['SA03']=sdata1[['A0301','A0302','A0303','A0304']].sum(axis='columns')
sdata1['SA04']=sdata1[['A0401','A0402','A0403']].sum(axis='columns')
sdata1['SA00']=sdata1[['SA01','SA02','SA03','SA04']].sum(axis='columns')
#B總和
sdata1['B01']=sdata1[['B0101','B0102','B0103','B0104','B0105','B0106','B0107','B0108']].mean(axis='columns')
sdata1['B02']=sdata1[['B0201','B0202','B0203','B0204','B0205','B0206']].mean(axis='columns')
sdata1['B03']=sdata1[['B0301','B0302','B0303','B0304']].mean(axis='columns')
sdata1['B04']=sdata1[['B0401','B0402','B0403']].mean(axis='columns')
sdata1['B00']=sdata1[['B01','B02','B03','B04']].mean(axis='columns')
#B單題平均
sdata1['SB01']=sdata1[['B0101','B0102','B0103','B0104','B0105','B0106','B0107','B0108']].sum(axis='columns')
sdata1['SB02']=sdata1[['B0201','B0202','B0203','B0204','B0205','B0206']].sum(axis='columns')
sdata1['SB03']=sdata1[['B0301','B0302','B0303','B0304']].sum(axis='columns')
sdata1['SB04']=sdata1[['B0401','B0402','B0403']].sum(axis='columns')
sdata1['SB00']=sdata1[['SB01','SB02','SB03','SB04']].sum(axis='columns')
#C總和
sdata1['C01']=sdata1[['C0101','C0102','C0103','C0104','C0105','C0106','C0107']].mean(axis='columns')
sdata1['C02']=sdata1[['C0201','C0202','C0203','C0204','C0205']].mean(axis='columns')
sdata1['C03']=sdata1[['C0301','C0302','C0303','C0304']].mean(axis='columns')
sdata1['C04']=sdata1[['C0401','C0402','C0403','C0404']].mean(axis='columns')
sdata1['C00']=sdata1[['C01','C02','C03','C04']].mean(axis='columns')
#C單題平均
sdata1['SC01']=sdata1[['C0101','C0102','C0103','C0104','C0105','C0106','C0107']].sum(axis='columns')
sdata1['SC02']=sdata1[['C0201','C0202','C0203','C0204','C0205']].sum(axis='columns')
sdata1['SC03']=sdata1[['C0301','C0302','C0303','C0304']].sum(axis='columns')
sdata1['SC04']=sdata1[['C0401','C0402','C0403','C0404']].sum(axis='columns')
sdata1['SC00']=sdata1[['SC01','SC02','SC03','SC04']].sum(axis='columns')
#進行相關分析
x1=sdata1['SA01']
y1=sdata1['SA02']
result1=x1.corr(y1)
print(result1)

import scipy.stats as stats
result2=stats.pearsonr(x1,y1)
print(result2[0])
print(result2[1])

#繪製散佈圖
#1.pandas
sdata1.plot.scatter(x='SA01',y='SA02')
#2.matplotlib
import matplotlib.pyplot as plt
plt.scatter(sdata1['SA01'],sdata1['SA02'], c='darkblue', alpha=0.5)
plt.show()
#3.seaborn
import seaborn as sns
sns.scatterplot(x='SA01',y='SA02', data=sdata1)
#多個變項的相關
result3 = sdata1[['SA01','SA02','SA03','SA04','SA00','SC01','SC02','SC03','SC04','SC00']].corr().round(4)
print(result3)

result3 = sdata1[['A01','A02','A03','A04','A00','C01','C02','C03','C04','C00']].corr().round(4)
print(result3)
#相關顯著性考驗
import scipy.stats as stats
result4=stats.pearsonr(sdata1['SA01'],sdata1['SA02'])
print(result4[0])
print(result4[1])

result40=[]
result41=[]
for i in sdata1[['SA01','SA02','SA03','SA04','SA00','SC01','SC02','SC03','SC04','SC00']].columns:
    result_temp0=[]
    result_temp1=[]
    for j in sdata1[['SA01','SA02','SA03','SA04','SA00','SC01','SC02','SC03','SC04','SC00']].columns:
        result4=stats.pearsonr(sdata1[j],sdata1[i])
        result_temp0.append(result4[0])
        result_temp1.append(result4[1])
    result40.append(result_temp0)
    result41.append(result_temp1)
result40 = pd.DataFrame(result40)
result41 = pd.DataFrame(result41)
print(result40.round(4))
print(result41.round(4))